#include "csapp.h"

/* Create multiple connections to an echo server at once,
   interlave reading and writing, and do that many times. */

#define NUM_CLIENTS 32
#define NUM_ITERS   10

int main(int argc, char **argv) {
  char *hostname, *port;
  int i, j;
  int fds[NUM_CLIENTS];
  char buf[MAXBUF], rbuf[MAXBUF];
  size_t amt;

  if (argc != 3)
    app_error("need <hostname> <port>");
  hostname = argv[1];
  port = argv[2];
  
  for (i = 0; i < NUM_ITERS; i++) {
    for (j = 0; j < NUM_CLIENTS; j++)
      fds[j] = Open_clientfd(hostname, port);
    
    for (j = 0; j < NUM_CLIENTS; j++) {
      snprintf(buf, MAXBUF, "client%d\n", j);
      Rio_writen(fds[j], buf, strlen(buf));
    }
    
    for (j = 0; j < NUM_CLIENTS; j++) {
      snprintf(buf, MAXBUF, "client%d\n", j);
      amt = Rio_readn(fds[j], rbuf, strlen(buf));
      rbuf[amt] = 0;
      if (strcmp(buf, rbuf))
        app_error("didn't get expected echo");
    }
    
    for (j = 0; j < NUM_CLIENTS; j++)
      Close(fds[j]);
  }

  return 0;
}
