#include "csapp.h"

/* Create multiple concurrent connections to an echo server
   by using a thread for each connection. */

#define NUM_CLIENTS 32
#define NUM_ITERS   10

#define DATA_COUNT  1000
#define DATA_SIZE   10

static char *hostname, *port;
static void *be_client(void *ignored);

int main(int argc, char **argv) {
  int i, j;
  pthread_t ths[NUM_CLIENTS];

  if (argc != 3)
    app_error("need <hostname> <port>");
  hostname = argv[1];
  port = argv[2];
  
  for (i = 0; i < NUM_ITERS; i++) {
    for (j = 0; j < NUM_CLIENTS; j++)
      Pthread_create(&ths[j], NULL, be_client, NULL);
    for (j = 0; j < NUM_CLIENTS; j++)
      Pthread_join(ths[j], NULL);
  }

  printf("Sent %d total\n", 
	 NUM_CLIENTS * NUM_ITERS * DATA_COUNT * DATA_SIZE);

  return 0;
}

void *be_client(void *ignored) {
  int fd, i;
  char data[DATA_SIZE];
  size_t amt, counter = 0;

  memset(data, 'x', DATA_SIZE);
  data[DATA_SIZE-1] = '\n';
  
  fd = Open_clientfd(hostname, port);

  for (i = 0; i < DATA_COUNT; i++) {
    Rio_writen(fd, data, DATA_SIZE);
    amt = Rio_readn(fd, data, DATA_SIZE);
    if (amt != DATA_SIZE)
      app_error("didn't get expected echo");
  }

  Close(fd);

  return NULL;
}
