#include "csapp.h"

void echo(int connfd);

void sigchld_handler(int sig)  { 
  while (waitpid(-1, 0, WNOHANG) > 0)
    ;
}

int main(int argc, char **argv) {
  int listenfd, connfd;
  char client_hostname[MAXLINE], client_port[MAXLINE];
  struct sockaddr_storage clientaddr; /* Enough room for any addr */

  if (argc != 2)
    app_error("need <port>");
  
  Signal(SIGCHLD, sigchld_handler);
  
  listenfd = Open_listenfd(argv[1]);
  while (1) {
    socklen_t clientlen = sizeof(struct sockaddr_storage);
    connfd = Accept(listenfd, (SA *)&clientaddr, &clientlen);

    if (Fork() == 0) {
      Close(listenfd);
      
      Getnameinfo((SA *) &clientaddr, clientlen,
                  client_hostname, MAXLINE, client_port, MAXLINE, 0);
      printf("Connected to (%s, %s)\n", client_hostname, client_port);

      echo(connfd);
      
      Close(connfd);
      exit(0);
    }
    Close(connfd);
  }
  
  return 0;
}

void echo(int connfd) {
  size_t n;
  char buf[MAXLINE];
  rio_t rio;
  
  Rio_readinitb(&rio, connfd);
  while((n = Rio_readlineb(&rio, buf, MAXLINE)) != 0) {
    printf("server received %ld bytes\n", n);
    Rio_writen(connfd, buf, n);
  }
}
