#include "csapp.h"
#include "sbuf.h"

#define SBUF_SIZE   64
#define NUM_THREADS 32

void *echo(void *ignored);

sbuf_t connfds;

int main(int argc, char **argv) {
int listenfd, connfd, i;
  char client_hostname[MAXLINE], client_port[MAXLINE];
  struct sockaddr_storage clientaddr; /* Enough room for any addr */
  pthread_t th;
  
  if (argc != 2)
    app_error("need <port>");

  sbuf_init(&connfds, SBUF_SIZE);
  
  for (i = 0; i < NUM_THREADS; i++) {
    Pthread_create(&th, NULL, echo, NULL);
    Pthread_detach(th);
  }
  
  listenfd = Open_listenfd(argv[1]);
  while (1) {
    socklen_t clientlen = sizeof(struct sockaddr_storage);
    connfd = Accept(listenfd, (SA *)&clientaddr, &clientlen);

    Getnameinfo((SA *) &clientaddr, clientlen,
		client_hostname, MAXLINE, client_port, MAXLINE, 0);
    printf("Connected to (%s, %s)\n", client_hostname, client_port);
  
    sbuf_insert(&connfds, connfd);
  }
  
  return 0;
}

void *echo(void *ignored) {
  int connfd;
  size_t n;
  char buf[MAXLINE];
  rio_t rio;

  while (1) {
    connfd = sbuf_remove(&connfds);
  
    Rio_readinitb(&rio, connfd);
    while((n = Rio_readlineb(&rio, buf, MAXLINE)) != 0) {
      printf("server received %ld bytes\n", n);
      Rio_writen(connfd, buf, n);
    }

    Close(connfd);
  }
}
